* /home/billw/Geoid/Intg2009beta/SCCS/s.getgrd.f
* @(#)getgrd.f	1.1	2009/08/05
*
* former - /ngslib/source/Geoid/Flib/SCCS/s.getgrd.f
* former - "@(#)getgrd.f 	1.23	2009/03/26 NGS"

* ---------------------------------------------------------------
* See sccs comments for modification history
* ---------------------------------------------------------------

      subroutine getgrd(imodel,dirnam,IS_SUBR, nfiles,fnam,lin,nff)
*---------------------------------------------------------------------
* Subroutine "get (geoid) grids"
* Fills a vector with the file names of the gridded input data,
* and open all files that can be found in the given directory.
* Additional geoid models may be added as developed.
*  in - imodel  : integer key to specific geoid model
*  in - dirnam  : directory location of binary geoid model files
*               : special- "ngs" is key to use NGS network files
*  in - IS_SUBR : run as subroutine: false=0;  true=1; (c std notation)
*  out- nfiles  : number of binary files used for the specific geoid model
*  out- fnam    : array (vector of character vectors) of geoid model filenames
*  out- lin     : vector of file unit numbers  (type = long int)
*               : of geoid model files opened in this subroutine
*  out- nff     : "Number of Files Found" and --successfully opened--
*---------------------------------------------------------------------
      implicit none
      integer       imodel
      character*256 dirnam
      integer       IS_SUBR
      integer       nfiles
      character*256 fnam(50)
      integer       lin(50)
      integer       nff

      character*80  SCCSID
      character*256 b256
      character*4   suf 
      character*2   cval
      character*40  b40

      integer       ios(50)
      integer       ii
      integer       ilen
      integer       lnblnk

      integer       imodel_old
      integer       IS_OPENED
      save          imodel_old
      save          IS_OPENED

ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Initialize variables
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      common /grid3/ ios
      SCCSID="@(#)getgrd.f	1.1	2009/08/05 NGS"

      b40 = '                                        '
      b256=b40//b40//b40//b40//b40//b40//'                '


ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Test if grid files are open for current geoid model
c - Return if opened, else initialize, fill vector, open grid files
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (imodel .eq. imodel_old .and. IS_OPENED .eq. 1) then
        return
      else
        imodel_old = imodel
        IS_OPENED = 0;
        do 10 ii=1,50
          fnam(ii) = b256
   10   continue
      endif


      if (dirnam.eq.b256) then
          ilen   = 0

c ----- Not Yet Implemented
c ----- BEGIN NGS network file locations

cc      elseif (dirnam(1:3).eq.'ngs') then
cc        if    (imodel.eq.1) then
cc          dirnam = '/ngslib/data/Geoid/Geoid99/'
cc          ilen   = lnblnk(dirnam)
cc        elseif(imodel.eq.2) then
cc          dirnam = '/ngslib/data/Geoid/G99sss/'
cc          ilen   = lnblnk(dirnam)
cc        elseif(imodel.eq.3) then
cc          dirnam = '/ngslib/data/Geoid/Geoid03/'
cc          ilen   = lnblnk(dirnam)
cc        elseif(imodel.eq.4) then
cc          dirnam = '/ngslib/data/Geoid/USGG2003/'
cc          ilen   = lnblnk(dirnam)
cc        elseif(imodel.eq.9) then
cc          dirnam = '/ngslib/data/Geoid/Geoid99/'
cc          ilen   = lnblnk(dirnam)
cc        endif
c ----- END   NGS network file locations

      else
        ilen = lnblnk(dirnam)
      endif

  109 format(i2.2)

ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Establish the suffix of files to be opened
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      suf = '.bin'


cccccccccccccccccccccccccccccccccccccc
c - The USGG2009BETA file names
cccccccccccccccccccccccccccccccccccccc
      if(    imodel.eq.6) then
        nfiles =  16
c - First 8 files are CONUS
        do 1601 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 's2009betau'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009betau'//cval//suf
          endif
 1601   continue

c - Next 4 files are ALASKA
        do 1602 ii=9,12
          write(cval,109) ii-8
          if (ilen.eq.0) then
            fnam(ii) =                 's2009betaa'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009betaa'//cval//suf
          endif
 1602   continue
 
c - Next 1 file is HAWAII
        do 1603 ii=13,13
          write(cval,109) ii-12
          if (ilen.eq.0) then
            fnam(ii) =                 's2009betah'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009betah'//cval//suf
          endif
 1603   continue
 
c - Next 1 file is GUAM/NMI
        do 1604 ii=14,14
          write(cval,109) ii-13
          if (ilen.eq.0) then
            fnam(ii) =                 's2009betag'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009betag'//cval//suf
          endif
 1604   continue

c - Next 1 file is SAMOA
        do 1605 ii=15,15
          write(cval,109) ii-14
          if (ilen.eq.0) then
            fnam(ii) =                 's2009betas'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009betas'//cval//suf
          endif
 1605   continue

c - Next 1 file is PR/VI
        do 1606 ii=16,16
          write(cval,109) ii-15
          if (ilen.eq.0) then
            fnam(ii) =                 's2009betap'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009betap'//cval//suf
          endif
 1606   continue


cccccccccccccccccccccccccccccccccccccc
c - The GEOID09BETA file names
cccccccccccccccccccccccccccccccccccccc
      elseif(imodel.eq.7) then
        nfiles = 16
c - First 8 files are CONUS
        do 1701 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009betau'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009betau'//cval//suf
          endif
 1701   continue

cc - Next 4 files are ALASKA
        do 1702 ii=9,12
          write(cval,109) ii-8
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009betaa'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009betaa'//cval//suf
          endif
 1702   continue
c 
c - Next 1 file is HAWAII
        do 1703 ii=13,13
          write(cval,109) ii-12
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009betah'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009betah'//cval//suf
          endif
 1703   continue

c - Next 1 file is GUAM - NORTHERN MARIANAS
        do 1704 ii=14,14
          write(cval,109) ii-13
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009betag'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009betag'//cval//suf
          endif
 1704   continue

cc - Next 1 file is SAMOA
        do 1705 ii=15,15
          write(cval,109) ii-14
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009betas'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009betas'//cval//suf
          endif
 1705   continue

c - Next 1 file is PR/VI
        do 1706 ii=16,16
          write(cval,109) ii-15
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009betap'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009betap'//cval//suf
          endif
 1706   continue


      endif

ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Now open all the files
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      do 201 ii=1,nfiles 
cDEBUG        write(6,205) fnam(ii)(1:(ilen+16) )
        open(lin(ii),file=fnam(ii),status='old',form='unformatted',
     *       access='direct',recl=4,iostat=ios(ii))
        if(ios(ii).eq.0)then
          if (IS_SUBR .ne. 0) then
            write(6,203) fnam(ii)(1:(ilen+16) )
          endif
        endif
  201 continue
  203 format(' *** Opening File: ',A)
  205 format(' Filename fnam(ii) = ',A)

      IS_OPENED = 1

ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Check and see if at least ONE file was opened,
c - and make a count of how many WERE opened.
c - Abort if we find no geoid files.
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      nff = 0
      do 207 ii=1,nfiles
        if(ios(ii).eq.0) nff = nff + 1
  207 continue

      if(nff.eq.0) then
        write(6,209) dirnam, imodel
        stop
      endif

  209 format(' *** ERROR(209):  No files found -- aborting',/
     *       ' input directory : ',A,/,
     *       ' input model code: ',I3)

      end

